%npml
% Uses em_npml to fit two-component mixture of Binomial logistic regressions
% Using NPML approach to fit measles data from Sherman and Le Cessie ('97)

path(path,'../program/npml');

format long;

global Y ID N N2 XMAT ZMAT WMAT BINN1 BINN2 ERRDIST1 ERRDIST2 PLINK MU1LINK;
global MU2LINK;

global YVAR LINKFUNCTION XVARS ERRDISFUNCTION SCALEPAR INC_CONST;
global OFFSET1 OFFSET2 WEIGHTS DETAILSFILE NAMEXV NAMELIST NAMEYV;

load 'measles.dat';
countyid=measles(:,1);
ID=countyid;
N=size(ID,1);
N2=max(ID);
Y=measles(:,2);
rate=measles(:,3);
nkids=measles(:,4);
year=measles(:,5);
BINN1=ones(N,1);
BINN2=BINN1;
yearmat=fac(year); %makes a matrix of indicators for all years except year=1
OFFSET1=log(nkids);
OFFSET2=log(nkids);
ID2=zeros(N,1);
for i=1:N2;
  ID2(ID==i)=[1:size(ID(ID==i),1)]';
end;

PLINK='logit';
MU1LINK='log';
MU2LINK='log';
ERRDIST1='poisson';
ERRDIST2='poisson';

XMAT=[rate];
ZMAT=[rate];
WMAT=[ones(N,1), rate];

glmlab;

alphainit=[-0.0944]';
betainit=[-0.14295]';
gammainit=[0.3029 0.009392]';

mquad=7;

diary npml_fridel.diary
[alpha,beta,gamma,quadwts,quadvals1,quadvals2,converge]=em_npml_fridel(alphainit,betainit,gammainit,mquad)
diary off

