function [alpha,beta,gamma,sigma,converge]=em(alphainit,betainit,gammainit,sigmainit,mquad1,changeit,mquad2)

% fits mixture of two exponential family GLMs each with random intercept
%Here, we'll use Adaptive Gaussian quadrature. 

% glmlab globals;
global YVAR LINKFUNCTION XVARS ERRDISFUNCTION SCALEPAR INC_CONST;
global OFFSET WEIGHTS DETAILSFILE NAMEXV NAMELIST NAMEYV;

global Y ID ID2 N N2 XMAT ZMAT WMAT BINN1 BINN2 ERRDIST1 ERRDIST2 MU1LINK 
global MU2LINK PLINK OFFSET1 OFFSET2;


clear paramtrs;
[toler,maxits,illctol]=paramtrs       %load defaults
BIG=1.0e10;
SMALL=1.0e-10;
converge=0;

%Setup Gaussian quadrature
[quadwts,quadvals]=getgaussherm(mquad1);
oquadvals=sqrt(2).*quadvals;
oquadwts=quadwts./sqrt(3.14159265358979);
mquad=mquad1;

alpha=alphainit
beta=betainit
gamma=gammainit
sigma=sigmainit

dimbeta=size(beta,1);
dimgamma=size(gamma,1);
dimalpha=size(alpha,1);
dimsigma=2;
dimparm=dimalpha+dimbeta+dimgamma+dimsigma;

its=0;
fail=0;
while (its<maxits)

  emitcount=0;
  while (emitcount<5000)
  emitcount=emitcount+1
  its=its+1

  if (its==changeit)
    [quadwts,quadvals]=getgaussherm(mquad2);
    oquadwts=quadwts./sqrt(3.14159265358979);
    oquadvals=sqrt(2)*quadvals;
    mquad=mquad2;
  end;

 
  alphaold=alpha; 
  betaold=beta;
  gammaold=gamma;
  sigmaold=sigma;
  
  alp=OFFSET1+XMAT*alpha;
  blp=OFFSET2+ZMAT*beta;
  glp=WMAT*gamma;
  p=getmixp(glp);
    
   if (its==1)
    b2vec=zeros(N2,1);
    b1vec=zeros(N2,1);  
  end;
  
  blupits=0;
  blup1converge=0;
  blup2converge=0;
  blupfail=1;
  maxblupits=20;
  while (blupits<maxblupits)
    blupits=blupits+1;
    b2vecold=b2vec;
    b1vecold=b1vec;
    
    if (blup2converge==0)
      b2score=getb2score(p,alp,blp,sigma,b2vec);
      b2neghessdiag= -nrdb2score(b2score,p,alp,blp,sigma,b2vec);
    end;
    if (blup1converge==0)
      b1score=getb1score(p,alp,blp,sigma,b1vec);
      b1neghessdiag= -nrdb1score(b1score,p,alp,blp,sigma,b1vec);
    end;

    if (blup2converge==0)
      b2vec=b2vec+ b2score./b2neghessdiag;   
      blup2maxchange=max(abs(b2vec-b2vecold));

      if (blup2maxchange<toler & norm(b2score)<toler)
        blup2converge=1
       end;
    end;
    if (blup1converge==0)
      b1vec=b1vec+ b1score./b1neghessdiag;   
      blup1maxchange=max(abs(b1vec-b1vecold));

      if (blup1maxchange<toler & norm(b1score)<toler)
        blup1converge=1
       end;
    end;

    if (blup1converge & blup2converge)
      blupits=maxblupits+1;
      blupfail=0;
    end;
  end;
  blupfail=blupfail  %when blupits>maxblupits and it still does not converge, the part is for checking purpose;
  if (blupfail)
    b1vec=b1vec
    b1neghessdiag=b1neghessdiag
    b2vec=b2vec
    b2neghessdiag=b2neghessdiag
  end;
  
  %calculate hessian matrix when we get the mode
  b2score=getb2score(p,alp,blp,sigma,b2vec);
  b2neghessdiag= -nrdb2score(b2score,p,alp,blp,sigma,b2vec);
  b1score=getb1score(p,alp,blp,sigma,b1vec);
  b1neghessdiag= -nrdb1score(b1score,p,alp,blp,sigma,b1vec);

  b1neghessdiag(b1neghessdiag<=0)=1;
  b2neghessdiag(b2neghessdiag<=0)=1; 
  
  for l=1:mquad;
    b1vecstar(:,l)=b1vec + sqrt(2)*quadvals(l)./sqrt(b1neghessdiag);
    b2vecstar(:,l)=b2vec + sqrt(2)*quadvals(l)./sqrt(b2neghessdiag);
  end;
  
    b2vec=b2vec;
    b2vecstar=b2vecstar;
    b2neghessdiag=b2neghessdiag;
 
  %M step for gamma
  warning off
  newmodel; 
  clear global YVAR XVARS;
  global YVAR LINKFUNCTION XVARS ERRDISFUNCTION SCALEPAR INC_CONST;
  global OFFSET WEIGHTS DETAILSFILE NAMEXV NAMELIST NAMEYV;
  warning on
  NAMEXV='[';
  for i=1:size(WMAT,2)
    NAMEXV=strcat(NAMEXV,'G'); 
    NAMEXV=strcat(NAMEXV,int2str(i));
    if (i~=size(WMAT,2))
      NAMEXV=strcat(NAMEXV,',');
    end;
  end;
  NAMEXV=strcat(NAMEXV,']');
  NAMEYV='[y]';
  NAMELIST=['Constant'];
  for i=1:size(WMAT,2)-1
    NAMELIST=str2mat(NAMELIST,['Gvar ',num2str(i)]);
  end;

  INC_CONST=0;
  
  fofyijcond=zeros(N,mquad);
  mu1cond=zeros(N,mquad);
  mu2cond=zeros(N,mquad);
  u=zeros(N,mquad); 
  ublup=zeros(N,1);
  
  W=zeros(N2,mquad);
  Wdenom=zeros(N2,mquad);
    
  fofyijcondi1=zeros(N2,mquad);
  fofyijcondi2=zeros(N2,mquad);
  for l=1:mquad; 
    for i=1:N2
      condalpi=alp(ID==i)+sigma(1)*b1vecstar(i,l);
      condblpi=blp(ID==i)+sigma(2)*b1vecstar(i,l);
      mu1condi=getmu1(condalpi,BINN1);
      mu2condi=getmu2(condblpi,BINN2);
      tempi= getf1cond(Y(ID==i),mu1condi,BINN1(ID==i)).*p(ID==i);
      fofyijcondi1(i,l)= prod(tempi+(1-p(ID==i)).*getf2cond(Y(ID==i),mu2condi,BINN2(ID==i)));
      u(ID==i,l)= tempi./(tempi+(1-p(ID==i)).*getf2cond(Y(ID==i),mu2condi,BINN2(ID==i)));

      condalpi=alp(ID==i)+sigma(1)*b2vecstar(i,l);
      condblpi=blp(ID==i)+sigma(2)*b2vecstar(i,l);
      mu1condi=getmu1(condalpi,BINN1);
      mu2condi=getmu2(condblpi,BINN2);
      tempi= getf1cond(Y(ID==i),mu1condi,BINN1(ID==i)).*p(ID==i);
      fofyijcondi2(i,l)= prod(tempi+(1-p(ID==i)).*getf2cond(Y(ID==i),mu2condi,BINN2(ID==i)));   
    end; %end i;

    W(:,l)= sqrt(2)*quadwts(l)*exp(quadvals(l)^2)*fofyijcondi1(:,l).*normpdf(b1vecstar(:,l))./sqrt(b1neghessdiag);
 
    Wdenom(:,l)= sqrt(2)*quadwts(l)*exp(quadvals(l)^2)*fofyijcondi2(:,l).*normpdf(b2vecstar(:,l))./sqrt(b2neghessdiag);
  end;  %end mquad;

  for l=1:mquad;
    W(:,l)=W(:,l)./sum(Wdenom,2);
    W(W(:,l)==Inf,l)=zeros(sum(W(:,l)==Inf),1);        
  end;
  
  YVAR=[stackrows(u),ones(N*mquad,1)];
  WEIGHTS=zeros(N*mquad,1);

  for i=1:N2;
    ti=size(ID(ID==i),1);
    WEIGHTS((((i-1)*ti*mquad)+1):(i*ti*mquad))= stackrows( kron(W(i,:),ones(ti,1)));
  end;
  wts=WEIGHTS;
  if any(YVAR(:,1).*wts<0)
    junk=YVAR(:,1).*wts;
    YVAR(junk<0,1)
    wts(junk<0)
  end;
  LINKFUNCTION=PLINK;
  XVARS=kron(WMAT,ones(mquad,1));
  ERRDISFUNCTION='binoml';
  OFFSET=zeros(size(YVAR,1),1);

  
  [gamma, fits, resids, glmcovgamma, covd, devlist]=glmfit;
  gamma=gamma(:,1);


  % M step for alpha
  warning off
  newmodel; 
  clear global YVAR XVARS;
  global YVAR LINKFUNCTION XVARS ERRDISFUNCTION SCALEPAR INC_CONST;
  global OFFSET WEIGHTS DETAILSFILE NAMEXV NAMELIST NAMEYV;
  warning on
  NAMEXV='[';
  for i=1:size(XMAT,2)+1
    NAMEXV=strcat(NAMEXV,'A'); 
    NAMEXV=strcat(NAMEXV,int2str(i));
    if (i~=size(XMAT,2))
      NAMEXV=strcat(NAMEXV,',');
    end;
  end;
  NAMEXV=strcat(NAMEXV,']');
  NAMEYV='[y]';
  NAMELIST=['Constant'];
  for i=1:size(XMAT,2)
    NAMELIST=str2mat(NAMELIST,['Avar ',num2str(i)]);
  end;

  if strcmp(ERRDIST1,'binoml')
    YVAR=kron([Y,BINN1],ones(mquad,1));
  else
    YVAR=kron([Y],ones(mquad,1));
  end;
  LINKFUNCTION=MU1LINK;
  XVARS=[ kron(XMAT,ones(mquad,1)),zeros(N*mquad,1)];
  for i=1:N2;
    ti=size(ID(ID==i),1);
    XVARS((((i-1)*ti*mquad)+1):(i*ti*mquad),dimalpha+1)= stackrows( kron(b1vecstar(i,:),ones(ti,1)));
  end;
  

  ERRDISFUNCTION=ERRDIST1;
  SCALEPAR=1;
  INC_CONST=0;
  OFFSET=kron(OFFSET1,ones(mquad,1));
  WEIGHTS=wts.*stackrows(u);
  
  [alphatmp fits resids glmcovalpha covd devlist]=glmfit;
  alpha=alphatmp(1:size(XMAT,2),1);
  sigma(1)=alphatmp(end,1);


  % M step for beta
  warning off
  newmodel;
  clear global YVAR XVARS;
  global YVAR LINKFUNCTION XVARS ERRDISFUNCTION SCALEPAR INC_CONST;
  global OFFSET WEIGHTS DETAILSFILE NAMEXV NAMELIST NAMEYV;
  warning on
  NAMEXV='[';
  for i=1:size(ZMAT,2)+1
    NAMEXV=strcat(NAMEXV,'B');
    NAMEXV=strcat(NAMEXV,int2str(i));
    if (i~=size(ZMAT,2))
      NAMEXV=strcat(NAMEXV,',');
    end;
  end;
  NAMEXV=strcat(NAMEXV,']');
  NAMEYV='[y]';
  NAMELIST=['Constant'];
  for i=1:size(ZMAT,2)
    NAMELIST=str2mat(NAMELIST,['Bvar ',num2str(i)]);
  end;

  if strcmp(ERRDIST2,'binoml')
    YVAR=kron([Y,BINN2],ones(mquad,1));
  else
    YVAR=kron([Y],ones(mquad,1));
  end;
  LINKFUNCTION=MU2LINK;
  XVARS=[ kron(ZMAT,ones(mquad,1)),zeros(N*mquad,1)];
  for i=1:N2;
    ti=size(ID(ID==i),1);
    XVARS((((i-1)*ti*mquad)+1):(i*ti*mquad),dimbeta+1)= stackrows( kron(b1vecstar(i,:),ones(ti,1)));
  end;
  
  ERRDISFUNCTION=ERRDIST2;
  SCALEPAR=1;
  INC_CONST=0;
  OFFSET=kron(OFFSET2,ones(mquad,1));
  WEIGHTS=wts.*stackrows(1-u);

  [betatmp fits resids glmcovbeta covd devlist]=glmfit;
  beta=betatmp(1:size(ZMAT,2),1);
  sigma(2)=betatmp(end,1);
  
  
  maxchange=max(abs([alpha-alphaold;beta-betaold;gamma-gammaold;sigma-sigmaold]))
  loglik= getloglikb(alpha,beta,gamma,sigma,quadwts,quadvals,b2vecstar,b2neghessdiag)

  if (maxchange<toler)
    converge=1
    its=maxits+1;
  end;

  if (converge==1)
    emitcount=5000;

    alp=OFFSET1+XMAT*alpha;
    blp=OFFSET2+ZMAT*beta;
    glp=WMAT*gamma;
    p=getmixp(glp);

  blupits=0;
  blup2converge=0;
  blupfail=1;
  maxblupits=30;
  while (blupits<maxblupits)
    blupits=blupits+1
    b2vecold=b2vec
       
    if (blup2converge==0)
      b2score=getb2score(p,alp,blp,sigma,b2vec);
      b2neghessdiag= -nrdb2score(b2score,p,alp,blp,sigma,b2vec);
    end;
  
    if (blup2converge==0)
      b2vec=b2vec+ b2score./b2neghessdiag;   
      blup2maxchange=max(abs(b2vec-b2vecold));

      if (blup2maxchange<toler & norm(b2score)<toler)
        blup2converge=1
       end;
    end;
 
    if (blup2converge)
      blupits=maxblupits+1;
      blupfail=0
    end;
  end;  %end of (while(blupits<maxblupits);
  if (blupfail)
      b2vec=b2vec
      b2neghessdiag=b2neghessdiag
  end;

  b2score=getb2score(p,alp,blp,sigma,b2vec);
  b2neghessdiag= -nrdb2score(b2score,p,alp,blp,sigma,b2vec);
  b2neghessdiag(b2neghessdiag<=0)=1;
  
  for l=1:mquad;
    b2vecstar(:,l)=b2vec + sqrt(2)*quadvals(l)./sqrt(b2neghessdiag);
  end;

  loglik= getloglikb(alpha,beta,gamma,sigma,quadwts,quadvals,b2vecstar,b2neghessdiag)

  NR_hess = gethessbaseloglik(loglik,b2vecstar,b2neghessdiag,alpha,beta,gamma,sigma,mquad,quadwts,quadvals)
  cov=inv(-NR_hess)

  end; % if converge

end; % while statement 
 
end;%while(its<maxits)
