function [b1score]=getb1score(p,alp,blp,sigma,b1vec)
% computes the score for computing "blup" of b1

global ID ID2 Y XMAT ZMAT WMAT N BINN1 BINN2 ERRDIST1 ERRDIST2 N2;
global MU1LINK MU2LINK PLINK;

b1score=zeros(N2,1);

for i=1:N2

  ti=size(ID(ID==i),1);
  pi=p(ID==i);
  Yi=Y(ID==i);
  BINN1i=BINN1(ID==i);
  BINN2i=BINN2(ID==i);
  alpi=alp(ID==i);
  blpi=blp(ID==i);

  condalpi=alpi+sigma(1)*b1vec(i);
  condblpi=blpi+sigma(2)*b1vec(i);
  mu1condi=getmu1(condalpi,BINN1i);
  mu2condi=getmu2(condblpi,BINN2i);
  tempi= getf1cond(Yi,mu1condi,BINN1i).*pi;
  ublupi= tempi./(tempi+(1-pi).*getf2cond(Yi,mu2condi,BINN2i));
      
  f1ih=getf1cond(Yi,getmu1(alpi+sigma(1)*b1vec(i),BINN1i));
  f2ih=getf2cond(Yi,getmu2(blpi+sigma(2)*b1vec(i),BINN2i));
  df1ihdbi=f1ih.*BINN1i.*sigma(1).*(Yi-getdkappa1(alpi+sigma(1)*b1vec(i)));
  df2ihdbi=f2ih.*BINN2i.*sigma(2).*(Yi-getdkappa2(blpi+sigma(2)*b1vec(i)));
  dlogf1ihdbi=BINN1i.*sigma(1).*(Yi-getdkappa1(alpi+sigma(1)*b1vec(i)));
  dlogf2ihdbi=BINN2i.*sigma(2).*(Yi-getdkappa2(blpi+sigma(2)*b1vec(i)));
  xx=(pi.*df1ihdbi+(1-pi).*df2ihdbi)./(pi.*f1ih+(1-pi).*f2ih);
  xx(isinf(xx)|isnan(xx))=0;
  b1score(i)= sum(xx) - b1vec(i);
  lci=getlci(ublupi,pi,alpi,blpi,i,b1vec(i),sigma);
  lci(isinf(lci)|isnan(lci))=0;

ef=1.0e-16;
   dublupidbi= (pi.*df1ihdbi.*(tempi+(1-pi).*getf2cond(Yi,mu2condi,BINN2i)) - tempi.*(pi.*df1ihdbi+(1-pi).*df2ihdbi))./((tempi+(1-pi).*getf2cond(Yi,mu2condi,BINN2i)).^2);
   ai=zeros(ti,1);    

   ai(abs(dublupidbi)>ef)=dublupidbi(abs(dublupidbi)>ef).*log(pi(abs(dublupidbi)>ef).*f1ih(abs(dublupidbi)>ef)./(1-pi(abs(dublupidbi)>ef))./f2ih(abs(dublupidbi)>ef));
   ai(ublupi==0)=ai(ublupi==0)+dlogf2ihdbi(ublupi==0);
   ai(ublupi==1)=ai(ublupi==1)+dlogf1ihdbi(ublupi==1);
   ai(ublupi~=0 & ublupi~=1)=ai(ublupi~=0 & ublupi~=1)+ublupi(ublupi~=0 & ublupi~=1).*dlogf1ihdbi(ublupi~=0 & ublupi~=1)+(1-ublupi(ublupi~=0 & ublupi~=1)).*dlogf2ihdbi(ublupi~=0 & ublupi~=1);

   kk=sum(ai)/sum(lci);
   kk(isinf(kk)|isnan(kk))=0;
  b1score(i)=b1score(i)+kk;
     
end;
