function [b2score]=getb2score(p,alp,blp,sigma,b2vec)
% computes the score for computing "blup" of b2

global ID ID2 Y XMAT ZMAT WMAT N BINN1 BINN2 ERRDIST1 ERRDIST2 N2;
global MU1LINK MU2LINK PLINK;

b2score=zeros(N2,1);

for i=1:N2

  ti=size(ID(ID==i),1);
  pi=p(ID==i);
  Yi=Y(ID==i);
  BINN1i=BINN1(ID==i);
  BINN2i=BINN2(ID==i);
  alpi=alp(ID==i);
  blpi=blp(ID==i);

  f1ih=getf1cond(Yi,getmu1(alpi+sigma(1)*b2vec(i),BINN1i));
  f2ih=getf2cond(Yi,getmu2(blpi+sigma(2)*b2vec(i),BINN2i));
  df1ihdbi=f1ih.*BINN1i.*sigma(1).*(Yi-getdkappa1(alpi+sigma(1)*b2vec(i)));
  df2ihdbi=f2ih.*BINN2i.*sigma(2).*(Yi-getdkappa2(blpi+sigma(2)*b2vec(i)));
  xx=(pi.*df1ihdbi+(1-pi).*df2ihdbi)./(pi.*f1ih+(1-pi).*f2ih);
  xx(isinf(xx)|isnan(xx))=0;
  b2score(i)= sum( xx ) - b2vec(i);
        
end;
