function [numhess]=gethessbaseloglik(loglik,b2vecstar,b2neghessdiag,alpha,beta,gamma,sigma,mquad,quadwts,quadvals)
% Calculates numerical second derivative of loglik with respect to parm
% where parm is  (gamma',alpha', sigma(1), beta', sigma(2))'
%
%

global ID ID2 Y XMAT ZMAT WMAT N BINN1 BINN2 ERRDIST1 ERRDIST2 OFFSET1 OFFSET2 N2;
global MU1LINK MU2LINK PLINK;


dimalpha=size(alpha,1);
dimbeta=size(beta,1);
dimgamma=size(gamma,1);
dimparm=dimbeta+dimgamma+dimalpha+2;
mquad=size(quadwts,1);

ef=2.2204e-16;
parm=[gamma;alpha;sigma(1);beta;sigma(2)];

numhess=zeros(dimparm,dimparm);
for j=1:dimparm
  for k=1:dimparm
      if (j~=k)

         x=parm(j);
         y=parm(k);

         if (x~=0)
            hx=(1+abs(x))*ef^(1/3);
         else
            hx=ef^(1/3);
         end;

         temp=x+hx;
         hx=temp-x;

         if (y~=0)
            hy=(1+abs(y))*ef^(1/3);
         else
            hy=ef^(1/3);
         end;

         temp=y+hy;
         hy=temp-y;


         farg1=parm;
         farg1(j)=parm(j)+hx;
         farg1(k)=parm(k)+hy;
         farg2=parm;
         farg2(j)=parm(j)+hx;
         farg2(k)=parm(k)-hy;
         farg3=parm;
         farg3(j)=parm(j)-hx;
         farg3(k)=parm(k)+hy;
         farg4=parm;
         farg4(j)=parm(j)-hx;   
         farg4(k)=parm(k)-hy;
         
    loglik1 = getloglikb(farg1((dimgamma+1):(dimgamma+dimalpha)),farg1((dimgamma+dimalpha+2):(dimgamma+dimalpha+dimbeta+1)),farg1(1:dimgamma),farg1([(dimgamma+dimalpha+1),dimparm]),quadwts,quadvals,b2vecstar,b2neghessdiag);
    loglik2 = getloglikb(farg2((dimgamma+1):(dimgamma+dimalpha)),farg2((dimgamma+dimalpha+2):(dimgamma+dimalpha+dimbeta+1)),farg2(1:dimgamma),farg2([(dimgamma+dimalpha+1),dimparm]),quadwts,quadvals,b2vecstar,b2neghessdiag);
    loglik3 = getloglikb(farg3((dimgamma+1):(dimgamma+dimalpha)),farg3((dimgamma+dimalpha+2):(dimgamma+dimalpha+dimbeta+1)),farg3(1:dimgamma),farg3([(dimgamma+dimalpha+1),dimparm]),quadwts,quadvals,b2vecstar,b2neghessdiag);
    loglik4 = getloglikb(farg4((dimgamma+1):(dimgamma+dimalpha)),farg4((dimgamma+dimalpha+2):(dimgamma+dimalpha+dimbeta+1)),farg4(1:dimgamma),farg4([(dimgamma+dimalpha+1),dimparm]),quadwts,quadvals,b2vecstar,b2neghessdiag);
    numhess(j,k) = (loglik1-loglik2-loglik3+loglik4)/(4*hx*hy);
  end; %end of if;
end;  %end of k;

         x=parm(j);
         if (x~=0)
            hx=(1+abs(x))*ef^(1/3);
         else
            hx=ef^(1/3);
         end;

         temp=x+hx;
         hx=temp-x;

         farg1=parm;
         farg1(j)=parm(j)+2*hx;
         farg2=parm;
         farg2(j)=parm(j)+hx;
         farg4=parm;
         farg4(j)=parm(j)-hx;
         farg5=parm;
         farg5(j)=parm(j)-2*hx;
       
    loglik1 = getloglikb(farg1((dimgamma+1):(dimgamma+dimalpha)),farg1((dimgamma+dimalpha+2):(dimgamma+dimalpha+dimbeta+1)),farg1(1:dimgamma),farg1([(dimgamma+dimalpha+1),dimparm]),quadwts,quadvals,b2vecstar,b2neghessdiag);
    loglik2 = getloglikb(farg2((dimgamma+1):(dimgamma+dimalpha)),farg2((dimgamma+dimalpha+2):(dimgamma+dimalpha+dimbeta+1)),farg2(1:dimgamma),farg2([(dimgamma+dimalpha+1),dimparm]),quadwts,quadvals,b2vecstar,b2neghessdiag);
    loglik4 = getloglikb(farg4((dimgamma+1):(dimgamma+dimalpha)),farg4((dimgamma+dimalpha+2):(dimgamma+dimalpha+dimbeta+1)),farg4(1:dimgamma),farg4([(dimgamma+dimalpha+1),dimparm]),quadwts,quadvals,b2vecstar,b2neghessdiag);
    loglik5 = getloglikb(farg5((dimgamma+1):(dimgamma+dimalpha)),farg5((dimgamma+dimalpha+2):(dimgamma+dimalpha+dimbeta+1)),farg5(1:dimgamma),farg5([(dimgamma+dimalpha+1),dimparm]),quadwts,quadvals,b2vecstar,b2neghessdiag);
    numhess(j,j) = (-1*loglik1+16*loglik2-30*loglik+16*loglik4-loglik5)/(12*hx*hx);

end;
