function [loglik]=getloglikb(alpha,beta,gamma,sigma,quadwts,quadvals,b2vecstar,b2neghessdiag)
% computes the logliklihood for the two-component mixture of GLMMs
% using adaptive gq to do the integration

global ID YVAR LINKFUNCTION VARFUNCTION XMAT OFFSET1 OFFSET2;
global Y N N2 ZMAT WMAT BINN1 BINN2 PLINK MU1LINK MU2LINK ERRDIST1 ERRDIST2;
SMALL=1.0e-6;


  alp=XMAT*alpha+OFFSET1;
  blp=ZMAT*beta+OFFSET2;
  glp=WMAT*gamma;
  p=getmixp(glp);


  mquad=size(b2vecstar,2);
  Wdenom=zeros(N2,mquad);
    
  fofyijcondi2=zeros(N2,mquad);
  for l=1:mquad; 
    for i=1:N2
      condalpi=alp(ID==i)+sigma(1)*b2vecstar(i,l);
      condblpi=blp(ID==i)+sigma(2)*b2vecstar(i,l);
      mu1condi=getmu1(condalpi,BINN1(ID==i));
      mu2condi=getmu2(condblpi,BINN2(ID==i));
      tempi= getf1cond(Y(ID==i),mu1condi,BINN1(ID==i)).*p(ID==i);
      fofyijcondi2(i,l)= prod(tempi+(1-p(ID==i)).*getf2cond(Y(ID==i),mu2condi,BINN2(ID==i)));
    end;
    Wdenom(:,l)= sqrt(2)*quadwts(l)*exp(quadvals(l)^2)*fofyijcondi2(:,l).*normpdf(b2vecstar(:,l))./sqrt(b2neghessdiag);        
  end;

loglik=sum(log(sum(Wdenom,2)));

