function [loglik]=getloglik(alpha,beta,gamma,mquad,quadwts,quadvals1,quadvals2)
% computes the logliklihood for the two-component mixture of GLMMs

global ID YVAR LINKFUNCTION VARFUNCTION XMAT OFFSET1 OFFSET2;
global Y N N2 ZMAT WMAT BINN1 BINN2 PLINK MU1LINK MU2LINK ERRDIST1 ERRDIST2 identity;
SMALL=1.0e-6;

    alp=XMAT*alpha+OFFSET1;
    blp=ZMAT*beta+OFFSET2;
    glp=WMAT*gamma;
    p=getmixp(glp);
    
    fofyijcond=zeros(N,mquad);
    for l=1:mquad
      mu1cond=getmu1( alp + identity(l,:)*quadvals1,BINN1);
      mu2cond=getmu2( blp + identity(l,:)*quadvals2,BINN2);
      fofyijcond(:,l)= p.*getf1cond(Y,mu1cond,BINN1)+(1-p).*getf2cond(Y,mu2cond,BINN2);
    end;
loglikvec=zeros(N2,1);
for i=1:N2
   kk = sum([ prod(fofyijcond(ID==i,:))]'.*quadwts);
   if (kk==0)
      kk=1;
   end;
  loglikvec(i)= log(kk);
end;

loglik= sum(loglikvec);

