function [mu]=getmu2(lp,bin)
% computes mean from 2nd distribution from linear predictor based on the chosen 
% link function for that distribution (MU2LINK)

global MU2LINK OFFSET2;


if strcmp(MU2LINK,'logit')
  mu=bin.*exp(lp)./(1+exp(lp));
elseif strcmp(MU2LINK,'probit')
  mu=bin.*normcdf(lp);
elseif strcmp(MU2LINK,'log')
  mu=exp(lp);
elseif strcmp(MU2LINK,'inverse')
  mu=1./lp;
elseif strcmp(MU2LINK,'identity')
  mu=lp;
end;

