function [wts,vals]=getgaussherm(mquad)
% computes the weights and abscissas for mquad-point Gauss-Hermite quadrature
%


MAXIT=10;
PIM4=0.7511255444649425;
EPS=3.0e-14;
vals=zeros(mquad,1);
wts=vals;

m=(mquad+1)/2;
for i=1:m
  if (i==1)
    z=sqrt(2*mquad+1)-1.85575*((2*mquad+1)^(-.16667));
  elseif (i==2)
    z=z-1.14*(mquad^(.426))/z;
  elseif (i==3)
    z=1.86*z-.86*vals(1);
  elseif (i==4)
    z=1.91*z-.91*vals(2);
  else
    z=2*z-vals(i-2);
  end;
  for its=1:MAXIT
    p1=PIM4;
    p2=0.0;
    for j=1:mquad
      p3=p2;
      p2=p1;
      p1=z*sqrt(2.0/j)*p2-sqrt((j-1)/j)*p3;
    end;
    pp=sqrt(2*mquad)*p2;
    z1=z;
    z=z1-p1/pp;
    if (abs(z-z1)<=EPS)
      break;
    end;
  end;
  if (its>MAXIT)
    gauherfail=1
    return;
  end;
  vals(i)=z;
  vals(mquad+1-i)=-z;
  wts(i)=2.0/(pp*pp);
  wts(mquad+1-i)=wts(i);
end;  
