function [loglik]=getloglik(alpha,beta,gamma,sigma,mquad,quadwts,quadvals)
% computes the logliklihood for the two-component mixture of GLMMs
% based on ordinary gaussian quadrature approximaiton;
 
global ID YVAR LINKFUNCTION VARFUNCTION XMAT OFFSET1 OFFSET2;
global Y N N2 ZMAT WMAT BINN1 BINN2 PLINK MU1LINK MU2LINK ERRDIST1 ERRDIST2;
SMALL=1.0e-6;

    alp=XMAT*alpha+OFFSET1;
    blp=ZMAT*beta+OFFSET2;
    glp=WMAT*gamma;
    p=getmixp(glp);
    
    fofyijcond=zeros(N,mquad);
    for l=1:mquad
      mu1cond_l=getmu1(alp+sigma(1)*quadvals(l),BINN1);
      mu2cond_l=getmu2(blp+sigma(2)*quadvals(l),BINN2);
      fofyijcond(:,l)= p.*getf1cond(Y,mu1cond_l,BINN1)+(1-p).*getf2cond(Y,mu2cond_l,BINN2);
    end;
loglikvec=zeros(N2,1);
for i=1:N2
  loglikvec(i)= log(sum([ prod(fofyijcond(ID==i,:))]'.*quadwts));
end;

loglik= sum(loglikvec);

