function [uwscore_1, wscore_2]=oakes_delta_h(old_uw, old_w,alpha,beta,gamma,sigma,mquad,quadwts,quadvals)
% Calculates numerical derivative with respect to parm
% where parm is  (gamma',alpha', sigma(1), beta', sigma(2))'

global ID ID2 Y XMAT ZMAT WMAT N BINN1 BINN2 ERRDIST1 ERRDIST2 N2;
global MU1LINK MU2LINK PLINK;


dimalpha=size(alpha,1);
dimbeta=size(beta,1);
dimgamma=size(gamma,1);
dimparm=dimbeta+dimgamma+dimalpha+2;
mquad=size(quadwts,1);

NN=N*mquad;
ef=1.0e-16;

uwscore_1=zeros(1,dimparm,NN);
wscore_2=zeros(1,dimparm,NN);

for j=1:dimgamma
    x=gamma(j);

    if (x~=0)
       h=x*ef^(1/2);
    else
       h=ef^(1/2);
    end;

    temp=x+h;
    h=temp-x;

    farg2=gamma;
    farg2(j)=gamma(j)-h;
    [uweight, weight]=oakes_weightu(alpha,beta,farg2,sigma,mquad,quadwts,quadvals);
    count=0;
    for i=1:N2 
        ti=size(ID(ID==i),1);
        for jj=1:ti
            for l=1:mquad
                count=count+1;
            
                partxminush_1=uweight(count);
                partxminush_2=weight(count);

                uwscore_1(1,j,count)=(old_uw(count)-partxminush_1)/(h);
                wscore_2(1,j,count)=(old_w(count)-partxminush_2)/(h);
            end; %l
         end; %jj
     end; %i
end; %j

for j=1:dimalpha

    x=alpha(j);

    if (x~=0)
      h=x*ef^(1/2);
    else
      h=ef^(1/2);
    end;

    temp=x+h;
    h=temp-x;

    farg2=alpha;
    farg2(j)=alpha(j)-h;

    [uweight, weight]=oakes_weightu(farg2,beta,gamma,sigma,mquad,quadwts,quadvals);

    count=0;
    for i=1:N2 
        ti=size(ID(ID==i),1);
        for jj=1:ti
            for l=1:mquad
                count=count+1;
            
                partxminush_1=uweight(count);
                partxminush_2=weight(count);

                uwscore_1(1,dimgamma+j,count)=(old_uw(count)-partxminush_1)/(h);
                wscore_2(1,dimgamma+j,count)=(old_w(count)-partxminush_2)/(h);
            end; %l
         end; %jj
     end; %i
end; %j

    x=sigma(1);

    if (x~=0)
      h=x*ef^(1/2);
    else
      h=ef^(1/2);
    end;

    temp=x+h;
    h=temp-x;

    farg2=sigma;
    farg2(1)=sigma(1)-h;

    [uweight, weight]=oakes_weightu(alpha,beta,gamma,farg2,mquad,quadwts,quadvals);

    count=0;
    for i=1:N2 
        ti=size(ID(ID==i),1);
        for jj=1:ti
            for l=1:mquad
                count=count+1;
            
                partxminush_1=uweight(count);
                partxminush_2=weight(count);

                uwscore_1(1,dimgamma+dimalpha+1,count)=(old_uw(count)-partxminush_1)/(h);
                wscore_2(1,dimgamma+dimalpha+1,count)=(old_w(count)-partxminush_2)/(h);
            end; %l
         end; %jj
     end; %i


for j=1:dimbeta

    x=beta(j);

    if (x~=0)
      h=x*ef^(1/2);
    else
      h=ef^(1/2);
    end;

    temp=x+h;
    h=temp-x;

    farg2=beta;
    farg2(j)=beta(j)-h;

    [uweight, weight]=oakes_weightu(alpha,farg2,gamma,sigma,mquad,quadwts,quadvals);

    count=0;
    for i=1:N2 
        ti=size(ID(ID==i),1);
        for jj=1:ti
            for l=1:mquad
                count=count+1;
            
                partxminush_1=uweight(count);
                partxminush_2=weight(count);

                uwscore_1(1,dimgamma+dimalpha+1+j,count)=(old_uw(count)-partxminush_1)/(h);
                wscore_2(1,dimgamma+dimalpha+1+j,count)=(old_w(count)-partxminush_2)/(h);
            end; %l
         end; %jj
     end; %i
end; %j

    x=sigma(2);

    if (x~=0)
      h=x*ef^(1/2);
    else
      h=ef^(1/2);
    end;

    temp=x+h;
    h=temp-x;
    
    farg2=sigma;
    farg2(2)=sigma(2)-h;

    [uweight, weight]=oakes_weightu(alpha,beta,gamma,farg2,mquad,quadwts,quadvals);

    count=0;
    for i=1:N2 
        ti=size(ID(ID==i),1);
        for jj=1:ti
            for l=1:mquad
                count=count+1;
            
                partxminush_1=uweight(count);
                partxminush_2=weight(count);

                uwscore_1(1,dimgamma+dimalpha+1+dimbeta+1,count)=(old_uw(count)-partxminush_1)/(h);
                wscore_2(1,dimgamma+dimalpha+1+dimbeta+1,count)=(old_w(count)-partxminush_2)/(h);
            end; %l
         end; %jj
     end; %i







