function [part_1, part_2]=oakes_part(alpha,beta,gamma,sigma,mquad,quadwts,quadvals)
% computes the logliklihood for the two-component mixture of GLMMs
% based on ordinary gaussian quadrature approximaiton;
 
global ID YVAR LINKFUNCTION VARFUNCTION XMAT OFFSET1 OFFSET2;
global Y N N2 ZMAT WMAT BINN1 BINN2 PLINK MU1LINK MU2LINK ERRDIST1 ERRDIST2;
SMALL=1.0e-6;

    alp=XMAT*alpha+OFFSET1;
    blp=ZMAT*beta+OFFSET2;
    glp=WMAT*gamma;
    p=getmixp(glp);
    
    mpart_1=zeros(N,mquad);
    mpart_2=zeros(N,mquad);

    mp=zeros(N,1);
    mp1=zeros(N,1);
    cc=zeros(N,1);
    for l=1:mquad
      mu1cond_l=getmu1(alp+sigma(1)*quadvals(l),BINN1);
      mu2cond_l=getmu2(blp+sigma(2)*quadvals(l),BINN2);

      dd=p.*getf1cond(Y,mu1cond_l,BINN1);
      kk=(1-p).*getf2cond(Y,mu2cond_l,BINN2);

      cc(dd==0)=zeros(size(dd(dd==0),1),1);
      cc(kk==0)=zeros(size(kk(kk==0),1),1);
      cc(kk~=0&dd~=0)=dd(kk~=0 & dd~=0)./kk(kk~=0 & dd~=0);
      cc(isinf(cc)|isnan(cc))=0;

      mp(cc==0)=zeros(size(cc(cc==0),1),1);
      mp(cc~=0)=log(cc(cc~=0));
      mp1(kk==0)=zeros(size(kk(kk==0),1),1);
      mp1(kk~=0)=log(kk(kk~=0));
      mpart_1(:,l)= mp;
      mpart_2(:,l)= mp1;
    end;

    part_1=stackrows(mpart_1);
    part_2=stackrows(mpart_2);


