options ls=78;

data fly;
  infile "wflyid.dat";
  input Immatures week block trt binomdenom live plantid;
  y=live;
  n=binomdenom;
  w0=0;
  %macro indicator;
   %do i=2 %to 12; 
       w0=0;
       if week = &i then w0=1;
	   w&i=w0;
   %end;
   %do i=2 %to 3; 
       b0=0;
       if block = &i then b0=1;
	   b&i=b0;
   %end;
   %do i=1 %to 5; 
       t0=0;
       if trt = &i then t0=1;
	   t&i=t0;
   %end;
   %do i=1 %to 5;
       %do j =2 %to 3;  
           tb0=0;
           if trt = &i and block = &j then tb0=1;
    	   tb&i.&j=tb0;
	   %end;
   %end;
   %do i=1 %to 5;
       %do j =2 %to 12; 
           tw0=0;
           if trt = &i and week = &j then tw0=1;
    	   tw&i.&j=tw0;
	   %end;
   %end;
   %mend;
   %indicator;
   drop w0 t0 b0;

run;

title "2_GLM: two-component mixture model"; 
proc nlmixed data=fly tech=CONGRA MAXIT=800  instep=1e-5 gconv=1e-8[2] maxfunc=30000; /*fd=central*/
 parms a1=-6.9145 ab2=2.48754 ab3=2.6154 at1=0.7443 at2=0.4907 at3=0.7157 at4=-0.8840 at5=5.1586 aw2=0.073 aw3=-0.079 aw4=0.2261 aw5=-0.045 aw6=0.065 aw7=-0.028 aw8=0.088 aw9=-0.086 aw10=0.034 aw11=0.0607 aw12=0.2604  
  c1=0.4858 cb2=0.9983 cb3=0.482 ct1=-0.6539 ct2=-0.4314 ct3=-0.7528 ct4=-0.6534 ct5=4.8573 cw2=-1.0001 cw3=-1.1211 cw4=-0.4255 cw5=-1.2515 cw6=-1.3286 cw7=-1.637 cw8=-1.537 cw9=-1.6662 cw10=-1.3955 cw11=-1.3962 cw12=-0.8745   
  b1=0.3831 bt1=0.6017 bt2=0.7544 bt3=1.0303 bt4=0.5308 bt5=-1.2573 bb2=0.6994 bb3=0.5510 bw2=-1.1666 bw3=-0.8965 bw4=-0.4818 bw5=0.1189 bw6=-0.1538 bw7=-0.6003 bw8=-0.819 bw9=0.09612 bw10=-0.6267 bw11=-0.3691 bw12=-1.6414;
  ef=1e-32;
  forpi1=a1+ab2*b2+ab3*b3+at1*t1+at2*t2+at3*t3+at4*t4+at5*t5+aw2*w2+aw3*w3+aw4*w4+aw5*w5+aw6*w6+aw7*w7+aw8*w8
       +aw9*w9+aw10*w10+aw11*w11+aw12*w12;  
  forpi2=c1+ ct1*t1+ct2*t2+ct3*t3+ct4*t4+ct5*t5  +  cb2*b2+cb3*b3  +  cw2*w2+cw3*w3+cw4*w4+cw5*w5+cw6*w6+cw7*w7+cw8*w8
       +cw9*w9+cw10*w10+cw11*w11+cw12*w12; 
  forp=b1+ bt1*t1+bt2*t2+bt3*t3+bt4*t4+bt5*t5  +  bb2*b2+bb3*b3  +  bw2*w2+bw3*w3+bw4*w4+bw5*w5+bw6*w6+bw7*w7+bw8*w8
       +bw9*w9+bw10*w10+bw11*w11+bw12*w12;
  p=exp(forp)/(1+exp(forp));

  pi1=exp(forpi1)/(1+exp(forpi1));
  pi2=exp(forpi2)/(1+exp(forpi2));
  f1 = exp(lgamma(n+1)-lgamma(y+1)-lgamma(n-y+1)+y*log(pi1/(1-pi1))+n*log(1-pi1));
  f2 = exp(lgamma(n+1)-lgamma(y+1)-lgamma(n-y+1)+y*log(pi2/(1-pi2))+n*log(1-pi2));
  if (abs(p)<ef) then likelihood=f2;
  else if (abs(1-p)<ef) then likelihood=f1;
  else likelihood=p*f1+(1-p)*f2;
  ll=log(likelihood);
  model y~general(ll);
run;
